#include <stdio.h>
#include <stdlib.h>
#include <locale.h>
#include <malloc.h>

typedef void (*task)();

int* createArr(int n)
{
    if (n <= 0) return NULL;

    int* array = calloc(n, sizeof(int));

    for (int i = 0; i < n; i++)
    {
        *(array + i) = i;
    }
    return array;
}

int** createTriangleArr(int n)
{
    if (n <= 0) return NULL;

    int** array = calloc(n, sizeof(int*));

    for (int i = 0; i < n; i++)
    {
        array[i] = calloc(i, sizeof(int));
    }

    int num = 0;
    for (size_t i = 0; i < n; i++)
    {
        for (size_t j = 0; j < i; j++)
        {
            **array = num++;
            ++*array;
        }
        *array -= i;
        array++;
    }
    array -= n;
    return array;
}

void outputTriangle(int n, int** arr)
{
    for (size_t i = 0; i < n; i++)
    {
        for (size_t j = 0; j < i; j++)
        {
            printf("%d ", **arr);
            ++*arr;
        }
        *arr -= i;
        ++arr;
        printf("\n");
    }
    arr -= n;
}

void output(int n, int* arr)
{
    for (size_t i = 0; i < n; i++)
    {
        printf("%d ", *arr + i);
    }
}

void deleteArr(int n, int* arr)
{
    free(arr);
}

int squar(int a)
{
    return a * a;
}

void task1()
{
    printf("\n 1\n");
    int a;
    printf("   (int): ");
    scanf_s("%d", &a);
    int* b = &a;
    printf(" a   1 = %d", *b);
    scanf_s("%d", &a);
    printf("  a = %d", *b);
}

void task2()
{
    printf("\n 2\n");
    int n = 1000000;
    int* arr = createArr(n);
    printf("\n \n");
    deleteArr(n, arr);
}

void task3()
{
    printf("\n 3\n");
    printf("  : ");
    int n;
    scanf_s("%d", &n);
    int* arr = createArr(n);
    output(n, arr);
}

void task4()
{
    printf("\n 4\n");
    printf("  : ");
    int n;
    scanf_s("%d", &n);
    int** arr = createTriangleArr(n);
    outputTriangle(n, arr);
}

void task5()
{
    int k;
    printf_s(" : ");
    scanf_s("%d", &k);
    int(*f)(int);
    f = squar;
    printf("%d", f(k));
}

int main()
{
    setlocale(LC_ALL, "Russian");
    printf(" ,  : \n1 -             \n2 -           int\n3 -          (      ) \n4 -   \n5 -   \n");
    int num;
    scanf_s("%d", &num);
    if (num == 1)
    {
        task1();
        main();
    }
    else if (num == 2)
    {
        task2();
        main();
    }
    else if (num == 3)
    {
        task3();
        main();
    }
    else if (num == 4)
    {
        task4();
        main();
    }
    else if (num == 5)
    {
        task5();
        main();
    }
    else
    {
        printf("  .  \n");
        main();
    }
}